﻿Imports System.Runtime.CompilerServices

Module DoubleStuff
    ' Format the value with the indicated number of significant digits.
    <Extension()> _
    Public Function ToSignificantDigits(ByVal value As Double, ByVal significant_digits As Integer) As String
        ' Use G format to get significant digits.
        ' Then convert to double and use F format.
        Dim format1 As String = "{0:G" + significant_digits.ToString() + "}"
        Dim result As String = Convert.ToDouble(String.Format(format1, value)).ToString("F99")

        ' Remove trailing 0s.
        result = result.TrimEnd("0"c)

        ' Remove the decimal point and leading 0s,
        ' leaving just the digits.
        Dim test As String = result.Replace(".", "").TrimStart("0"c)

        ' Add trailing 0s if necessary.
        If (significant_digits > test.Length) Then
            result &= New String("0"c, significant_digits - test.Length)
        End If

        Return result
    End Function
End Module
